;---------------------------------------------------------------------
key:
	mcall	2
	cmp	[extended_key],1
	je	.extended_key

	test	al,al
	jnz	still

	cmp	ah,0xE0
	jne	@f

	mov	[extended_key],1
	jmp	still
;--------------------------------------
@@:
	cmp	ah,72	; arrow up
	je	.arrow_up

	cmp	ah,80	; arrow down
	je	.arrow_down

	cmp	ah,75	; arrow left
	je	.arrow_left

	cmp	ah,77	; arrow right
	je	.arrow_right

	cmp	ah,17	; w - arrow up
	je	.arrow_up

	cmp	ah,31	; s - arrow down
	je	.arrow_down

	cmp	ah,30	; a - arrow left
	je	.arrow_left

	cmp	ah,32	; d - arrow right
	je	.arrow_right

	cmp	ah,57	; space - kick
	je	.kick	

	jmp	still
;---------------------------------------------------------------------
.extended_key:
	mov	[extended_key],0
	cmp	ah,72	; arrow up
	je	.arrow_up

	cmp	ah,80	; arrow down
	je	.arrow_down

	cmp	ah,75	; arrow left
	je	.arrow_left

	cmp	ah,77	; arrow right
	je	.arrow_right

	jmp	still
;---------------------------------------------------------------------
.arrow_up:
	cmp	[protagonist_route],ROUTE_UP
	je	@f

	mov	[protagonist_route],ROUTE_UP
	call	show_protagonist_1
;--------------------------------------
@@:
	cmp	[protagonist_position.y],0
	je	calculate_action_for_all.1	;still

	mov	eax,[protagonist_position.y]
	dec	eax
	call	calculate_offset.1
	call	calculate_protagonist_vs_brick

	mov	ecx,0x01000000
	call	calculate_protagonist_position
	sub	[protagonist_position.y],1
.show_protagonist:
	mov	ecx,0x01000300
	call	calculate_protagonist_position
;	call	show_textures
	jmp	calculate_action_for_all	;still
;---------------------------------------------------------------------
.arrow_down:
	cmp	[protagonist_route],ROUTE_DOWN
	je	@f

	mov	[protagonist_route],ROUTE_DOWN
	call	show_protagonist_1
;--------------------------------------
@@:
	cmp	[protagonist_position.y],LEVEL_MAP_SIZE_Y-1
	je	calculate_action_for_all.1	;still

	mov	eax,[protagonist_position.y]
	inc	eax
	call	calculate_offset.1
	call	calculate_protagonist_vs_brick

	mov	ecx,0x01000000
	call	calculate_protagonist_position
	add	[protagonist_position.y],1
	jmp	.show_protagonist
;---------------------------------------------------------------------
.arrow_left:
	cmp	[protagonist_route],ROUTE_LEFT
	je	@f

	mov	[protagonist_route],ROUTE_LEFT
	call	show_protagonist_1
;--------------------------------------
@@:
	cmp	[protagonist_position.x],0
	je	calculate_action_for_all.1	;still

	call	calculate_offset
	dec	ebx
	call	calculate_protagonist_vs_brick

	mov	ecx,0x01000000
	call	calculate_protagonist_position
	sub	[protagonist_position.x],1
	jmp	.show_protagonist
;---------------------------------------------------------------------
.arrow_right:
	cmp	[protagonist_route],ROUTE_RIGHT
	je	@f

	mov	[protagonist_route],ROUTE_RIGHT
	call	show_protagonist_1
;--------------------------------------
@@:
	cmp	[protagonist_position.x],LEVEL_MAP_SIZE_X-1
	je	calculate_action_for_all.1	;still

	call	calculate_offset
	inc	ebx
	call	calculate_protagonist_vs_brick

	mov	ecx,0x01000000
	call	calculate_protagonist_position
	add	[protagonist_position.x],1
	jmp	.show_protagonist
;---------------------------------------------------------------------
.kick:
	mov	eax,[protagonist_route]
	cmp	al,ROUTE_UP
	jne	@f
	
	cmp	[protagonist_position.y],0
	je	calculate_action_for_all.1	;still
	
	call	protagonist_kick_action
	mov	eax,[protagonist_position.y]
	dec	eax
	call	calculate_offset.1
	jmp	.calculate_protagonist_kick_brick
;--------------------------------------	
@@:
	cmp	al,ROUTE_DOWN
	jne	@f

	cmp	[protagonist_position.y],LEVEL_MAP_SIZE_Y-1
	je	calculate_action_for_all.1	;still

	call	protagonist_kick_action
	mov	eax,[protagonist_position.y]
	inc	eax
	call	calculate_offset.1
	jmp	.calculate_protagonist_kick_brick
;--------------------------------------	
@@:
	cmp	al,ROUTE_LEFT
	jne	@f

	cmp	[protagonist_position.x],0
	je	calculate_action_for_all.1	;still

	call	protagonist_kick_action
	call	calculate_offset
	dec	ebx
	jmp	.calculate_protagonist_kick_brick
;--------------------------------------	
@@:
	cmp	al,ROUTE_RIGHT
	jne	still
	
	cmp	[protagonist_position.x],LEVEL_MAP_SIZE_X-1
	je	calculate_action_for_all.1	;still	
	
	call	protagonist_kick_action
	call	calculate_offset
	inc	ebx
;--------------------------------------
.calculate_protagonist_kick_brick:
	shl	ebx,2
	add	eax,ebx
	add	eax,plan_level
	mov	ebx,[eax]
	
	cmp	bh,3
	jbe	.kill

	cmp	bh,4 ; red brick?
	jne	still

	and	ebx,0x00ff00ff
	add	ebx,0x01008000	; 0x80 - reb brick crash 1
	mov	[eax],ebx
	push	eax ebx
;        DEBUGF  1, "80 - reb brick crash 10\n"	
	call	show_textures
	mcall	5,10
	pop	ebx eax

	and	ebx,0x00ff00ff
	add	ebx,0x01008100	; 0x81 - reb brick crash 2
	mov	[eax],ebx
	push	eax ebx
;        DEBUGF  1, "81 - reb brick crash 20\n"
	call	show_textures
	mcall	5,10
	pop	ebx eax

	and	ebx,0x00ff00ff	
	add	ebx,0x01000000
	mov	[eax],ebx
;        DEBUGF  1, "81 - reb brick crash 30\n"
;	call	show_textures
	jmp	calculate_action_for_all	;still
	
.kill:
	and	ebx,0x000000ff	
	add	ebx,0x01000000
	mov	[eax],ebx
;	call	show_textures
	jmp	calculate_action_for_all
;---------------------------------------------------------------------
calculate_action_for_all:
	call	show_textures
.1:
	call	actions_for_all
	call	show_textures
	jmp	still
;---------------------------------------------------------------------
calculate_offset:
	mov	eax,[protagonist_position.y]
.1:
	imul	eax,LEVEL_MAP_SIZE_X*4
	mov	ebx,[protagonist_position.x]
	ret
;---------------------------------------------------------------------
protagonist_kick_action:
	add	[protagonist_route],4
	call	show_protagonist_1
	sub	[protagonist_route],4
	call	show_protagonist_1
	ret
;---------------------------------------------------------------------
calculate_protagonist_vs_brick:
	shl	ebx,2
	add	eax,ebx
	add	eax,plan_level
	mov	ebx,[eax]
;	cmp	bh,4 ; brick?
	test	bh,bh ; empty?
	jnz	@f
	
	ret
@@:
	add	esp,4
	jmp	still
;---------------------------------------------------------------------
show_protagonist_1:
	mov	ecx,0x01000300
	call	calculate_protagonist_position
	call	show_textures
	call	actions_for_all
	call	show_textures
	mcall	5,20
	ret
;---------------------------------------------------------------------
calculate_protagonist_position:
	call	calculate_offset
	shl	ebx,2
	add	eax,ebx
	add	eax,plan_level
	mov	ebx,[eax]
	and	ebx,0x00ff00ff
	add	ebx,ecx
	mov	[eax],ebx
	ret
;---------------------------------------------------------------------
