;---------------------------------------------------------------------
show_textures:
;        DEBUGF  1 "show_textures\n"
	; set start coordinates
	xor	edx,edx
	mov	ebx,LEVEL_MAP_SIZE_Y
	mov	ecx,plan_level
;--------------------------------------
.new_y:
	mov	eax,LEVEL_MAP_SIZE_X
	ror	edx,16
	xor	dx,dx
	rol	edx,16
;--------------------------------------
.new_x:
	push	eax ebx ecx

	mov	ebp,[ecx]
	
	cmp	[draw_all_level],1
	je	@f
;        DEBUGF  1 "Y : %x X: %x cell: %x ebp: %x\n",ebx,eax,ecx,ebp	
	mov	eax,ebp
	rol	eax,8
	test	al,al
	mov	al,0
	jz	.end_show_buffer
	
	ror	eax,8
	mov	[ecx],eax
;        DEBUGF  1 "new cell: %x eax: %x\n",ecx,eax
;--------------------------------------
@@:
	and	ebp,0xff
	imul	ebp,SPRITE_SIZE_X*SPRITE_SIZE_Y*3 ; 24bpp
	mov	eax,[ground_icons]
	call	copy_ground
	
	mov	ebp,[ecx]
	shr	ebp,8
	and	ebp,0xff
	test	ebp,ebp
	jz	.no_characters

	mov	eax,[characters_icons]
	cmp	ebp,3	; our protagonist
	jnz	@f
	
	mov	eax,[protagonist_icons]
	mov	ebp,[protagonist_route]
	jmp	.copy_characters
;--------------------------------------
@@:
	cmp	ebp,0x80	; 0x80 - reb brick crash 1
	jnz	@f
;;        DEBUGF  1 "80 - reb brick crash 11\n"	
	mov	eax,[red_brick_icons]
	mov	ebp,1
	jmp	.copy_characters
;--------------------------------------
@@:
	cmp	ebp,0x81	; 0x81 - reb brick crash 2
	jnz	@f
;;        DEBUGF  1 "81 - reb brick crash 21\n"		
	mov	eax,[red_brick_icons]
	mov	ebp,2
;--------------------------------------
@@:
.copy_characters:
	dec	ebp
	imul	ebp,SPRITE_SIZE_X*SPRITE_SIZE_Y*4 ; 32bpp
	call	copy_characters
;--------------------------------------
.no_characters:	
	xor	ebp,ebp
	mcall	65,buffer_area,<SPRITE_SIZE_X,SPRITE_SIZE_Y>,,32	; 32bpp
;--------------------------------------
.end_show_buffer:
	pop	ecx ebx eax
	
	add	ecx,4
	add	edx,SPRITE_SIZE_X shl 16
	dec	eax
	jnz	.new_x
	
	add	edx,SPRITE_SIZE_Y
	dec	ebx
	jnz	.new_y
;        DEBUGF  1 "show_textures END\n"
	ret
;---------------------------------------------------------------------
copy_ground:
;;        DEBUGF  1 "copy_ground\n"
	push	ecx
	mov	esi,[eax+28]
	add	esi,eax
	add	esi,ebp
	mov	edi,buffer_area
	mov	ecx,SPRITE_SIZE_X*SPRITE_SIZE_Y
	cld
;--------------------------------------
@@:
	lodsd
	and	eax,0xffffff
	dec	esi
	stosd
	dec	ecx
	jnz	@b

	pop	ecx
;;        DEBUGF  1 "copy_ground end\n"
	ret
;---------------------------------------------------------------------
copy_characters:
;;        DEBUGF  1 "copy_characters\n"
	mov	esi,[eax+28]
	add	esi,eax
	add	esi,ebp
	mov	edi,buffer_area
	mov	ecx,SPRITE_SIZE_X*SPRITE_SIZE_Y
	cld
;--------------------------------------
@@:
	lodsd
	rol	eax,8
	test	al,al
	jz	.transparently
	
	ror	eax,8
	mov	[edi],eax
;--------------------------------------
.transparently:
	add	edi,4
	dec	ecx
	jnz	@b
;;        DEBUGF  1 "copy_characters end\n"	
	ret
;---------------------------------------------------------------------
